/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.client.controler.admin;

import com.evasion.client.controler.ApplicationContext;
import com.evasion.common.Constante;
import com.evasion.common.Utils;
import com.evasion.ejb.local.ParametreManagerLocal;
import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.RequestScoped;
import javax.faces.context.FacesContext;
import javax.validation.constraints.NotNull;

/**
 *
 * @author sebastien.glon
 */
@ManagedBean
@RequestScoped
public class FormConfigSite implements com.evasion.common.controler.FormConfigSite {

    @EJB
    private ParametreManagerLocal ejb;

    @ManagedProperty(name = "", value = "#{applicationContext}")
    ApplicationContext applicationContext;

    private String titre;

    private String contactResp;

    private String contactSupport;

    private String description;

    private String sujet;

    private String keyword;

    private String analyticsAccount;

    private boolean isSucces;

    @PostConstruct
    public void reset() {
        titre = Utils.isEmpty(ejb.getProperty(Constante.TITRE_SITE)) ? "Mon site" : ejb.getProperty(Constante.TITRE_SITE);
        contactResp = Utils.isEmpty(ejb.getProperty(Constante.CONTACT_RESP)) ? "contact@localhost.fr" : ejb.getProperty(Constante.CONTACT_RESP);
        contactSupport = Utils.isEmpty(ejb.getProperty(Constante.CONTACT_SUPPORT)) ? "contact@localhost.fr" : ejb.getProperty(Constante.CONTACT_SUPPORT);
        analyticsAccount = Utils.isEmpty(ejb.getProperty(Constante.ANALYTICS_ACCOUNT)) ? "" : ejb.getProperty(Constante.ANALYTICS_ACCOUNT);
        description = "";
        sujet = "";
        keyword = "";
        isSucces = false;
    }

    public String validForm() {
        ejb.saveParametre(Constante.TITRE_SITE, titre, Boolean.TRUE);
        ejb.saveParametre(Constante.CONTACT_RESP, contactResp, Boolean.TRUE);
        ejb.saveParametre(Constante.CONTACT_SUPPORT, contactSupport, Boolean.TRUE);
        ejb.saveParametre(Constante.ANALYTICS_ACCOUNT, analyticsAccount, Boolean.TRUE);
//        validMessage = new UIMessage();
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO,
                "Les données ont été correctement sauvegardé", ""));
        applicationContext.initParam();
        return "Succes";
    }

    public ApplicationContext getApplicationContext() {
        return applicationContext;
    }

    public void setApplicationContext(ApplicationContext applicationContext) {
        this.applicationContext = applicationContext;
    }

    //----------- Getter Setter --------------------------//
    @Override
    @NotNull
    public String getTitre() {
        return titre;
    }

    @Override
    public void setTitre(String titre) {
        this.titre = titre;
    }

    @Override
    public String getContactResp() {
        return contactResp;
    }

    @Override
    public void setContactResp(String contact) {
        contactResp = contact;
    }

    @Override
    public String getContactSupport() {
        return contactSupport;
    }

    @Override
    public void setContactSupport(String contact) {
        contactSupport = contact;
    }

    @Override
    public String getDescription() {
        return description;
    }

    @Override
    public void setDescription(String desc) {
        description = desc;
    }

    @Override
    public String getSujet() {
        return sujet;
    }

    @Override
    public void setSujet(String s) {
        sujet = s;
    }

    @Override
    public String getKeyword() {
        return keyword;
    }

    @Override
    public void setKeyword(String k) {
        keyword = k;
    }

    @Override
    public String getAnalyticsAccount() {
        return analyticsAccount;
    }

    @Override
    public void setAnalyticsAccount(String analytics) {
        this.analyticsAccount = analytics;
    }
}
