/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.client.controler.booktravel;

import com.evasion.common.Constante;
import com.evasion.common.Utils;
import com.evasion.ejb.local.ParametreManagerLocal;
import com.evasion.entity.booktravel.RoadMap;
import com.evasion.module.travel.ITravelModule;
import java.io.Serializable;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.Map;
import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.component.UIData;
import javax.faces.context.FacesContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 *
 * @author sebastien
 */
@ManagedBean
@RequestScoped
public class RoadmapsView implements Serializable {

    /***
     * serialVersionUID.
     */
    private static final long serialVersionUID = 1L;
    /**
     * LOGGER.
     */
    private static final Logger LOGGER = LoggerFactory.getLogger(
            RoadmapsView.class);
    @EJB
    ParametreManagerLocal paramEJB;
    @EJB
    private ITravelModule bookTravelEJB;
    private Date dateDebut;
    private Date dateFin;
    private List<RoadMap> resultatRecherche;
    private UIData selectedRow;
        private Long currentBookTravelID;

    @PostConstruct
    public void init() throws Exception {
        Map params = FacesContext.getCurrentInstance().
                getExternalContext().getRequestParameterMap();
        String id = (String) params.get("id");
            if (Utils.isEmpty(id)) {
                currentBookTravelID = (Long) FacesContext.getCurrentInstance().
                        getExternalContext().getSessionMap().
                        get("currentBookTravelID");
            } else {
                currentBookTravelID = Long.parseLong(id);
            }

            FacesContext.getCurrentInstance().
                    getExternalContext().getSessionMap().put("currentBookTravelID", currentBookTravelID);


        if (dateFin == null) {
            Calendar now = GregorianCalendar.getInstance();
            dateFin = now.getTime();
        }

        if (dateDebut == null) {
            Calendar nowSubstractMonth = GregorianCalendar.getInstance();
            nowSubstractMonth.add(GregorianCalendar.MONTH, -1);
            dateDebut = nowSubstractMonth.getTime();
        }
        doFind();
    }

    public void doFind() {
       resultatRecherche = bookTravelEJB.getArchiveRoadMapBetweenDate(currentBookTravelID, dateDebut, dateFin);
        
    }

    public UIData getSelectedRow() {
        return selectedRow;
    }

    public void setSelectedRow(UIData selectedRow) {
        this.selectedRow = selectedRow;
    }

    public Date getDateDebut() {
        return dateDebut;
    }

    public void setDateDebut(Date dateDebut) {
        this.dateDebut = dateDebut;
    }

    public Date getDateFin() {
        return dateFin;
    }

    public void setDateFin(Date dateFin) {
        this.dateFin = dateFin;
    }

    public List<RoadMap> getResultatRecherche() {
        return resultatRecherche;
    }

    public void setResultatRecherche(List<RoadMap> resultatRecherche) {
        this.resultatRecherche = resultatRecherche;
    }
}
